/*----------------------------------DataTolib V2.0 function-----------------------------*/




int number_of_entry(SYM_ENTRY *file)
{//retourne le nombre d'entre

	unsigned char *VarPtr=NULL;
	unsigned int offset;
	VarPtr= (unsigned char*)HeapDeref (file->handle);
	offset=*(unsigned int *)(VarPtr+8);
	//offset de la premiere donne
	 return (offset-6)/2;
}

void *extract_data(int numero,SYM_ENTRY *file)//retourne la n ieme donnes
{
	unsigned char *VarPtr=NULL;
	unsigned int offset;
	
	VarPtr= (unsigned char*)HeapDeref (file->handle);
	offset=*(unsigned int *)(VarPtr+8+numero*2);
  return (void *)(VarPtr+2+offset);//le 2 correpond aux deux premiers octets du fichier qui definisse sa taille
return NULL;
		
}



int sizeof_entry(int n,SYM_ENTRY *file)
{
	unsigned char *VarPtr=NULL;
	unsigned int taille,offset;
	//definit la taille de l'entre n
	//facile pour les n-1 entre pour la n on se base que le fichier total
	
	if(n<(number_of_entry(file)-1))
	{
		return (int)(extract_data(n+1,file)-extract_data(n,file));
	
		
	}
	else
	{
		VarPtr= (unsigned char*)HeapDeref (file->handle);
		taille=*(unsigned int *)(VarPtr);//taille du fichier
		offset=*(unsigned int *)(VarPtr+8+n*2);
		return taille-offset-6;
		
		
	}
	
}



int search_version(SYM_ENTRY *file)//retourne le numero de version du fichier
{
	unsigned int *VarPtr=NULL;		
	
	VarPtr= (unsigned int*)HeapDeref (file->handle);
	return *(VarPtr+3);
	
}


char *search_signature(SYM_ENTRY *file)//retourne un pointeur vers une la chaine de caractere de la signature
{

unsigned int *VarPtr=NULL;		
	
VarPtr= (unsigned int*)HeapDeref (file->handle);
return (unsigned char *)(VarPtr)+2;	
}



/***********************fonction spcifique aux fonctions**************************************/


void *alloc_func(int n,SYM_ENTRY *file)
{
	void *func;
	void *data;
	unsigned int size;
	short len;	
	size=sizeof_entry(n,file);
	func=malloc(size);
  data=extract_data(n,file);
  memcpy(func,data,size);
	
  len=*((short *)func);
  EX_patch (func + 2, func + len + 1);
  func+=2;



	return func;
}

//(*(void (*)(int, int, long, float))fptr)(1,2,3,4.);


void release_func(void *func)
{
	
	free(func-2);

}