// C Source File
// Created 01/11/2002; 12:46:24

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

// #define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "Datatolib.h"
// Main Function
typedef enum _nomdata
{
string1,
string2,
func_hello
}NOMDATA;




//Iunknown interface[1]={clrscr};

void _main(void)
{
	SYM_ENTRY *file;
	int a,b;
	void *func;
	
	
	clrscr();
	file=DerefSym (SymFind ($(lib1)));
	printf("signature %s\n",search_signature(file));
	printf("version number %d\n",search_version(file));
	printf("number of entry %d\n",number_of_entry(file));
	printf("sizeof entry 0:%d\n",sizeof_entry(0,file));
	printf("sizeof entry 1:%d\n",sizeof_entry(1,file));
	printf("sizeof entry 2:%d\n",sizeof_entry(2,file));
	
	
	printf("donnes1:%s\n",(char *)extract_data(string1,file));
	printf("donnes2:%s\n",(char *)extract_data(string2,file));
	ngetchx();
	enter_ghost_space();
	func=alloc_func(func_hello,file);
	
	(*(void (*)(void))func)();
	
	release_func(func);
	

	
}
